Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -4084,46 +4072,112 @@
                 ibit3_s = REAL( IBITS(advc_flag(k,j-1,i),3,1), KIND = wp )
 
-                v_comp_s = v(k,j,i) - v_gtrans + v_stokes_zu(k)
-                flux_s = v_comp_s * (                                         &
-                                             ( 37.0_wp * ibit5_s * adv_sca_5  &
-                                          +     7.0_wp * ibit4_s * adv_sca_3  &
-                                          +              ibit3_s * adv_sca_1  &
-                                             ) *                              &
-                                         ( sk(k,j,i)  + sk(k,j-1,i)     )     &
-                                       -     (  8.0_wp * ibit5_s * adv_sca_5  &
-                                          +              ibit4_s * adv_sca_3  &
-                                              ) *                             &
-                                         ( sk(k,j+1,i) + sk(k,j-2,i)    )     &
-                                      +      (           ibit5_s * adv_sca_5  &
-                                             ) *                              &
-                                        ( sk(k,j+2,i) + sk(k,j-3,i)     )     &
-                                             )
-
-                diss_s = -ABS( v_comp_s ) * (                                 &
-                                             ( 10.0_wp * ibit5_s * adv_sca_5  &
-                                          +     3.0_wp * ibit4_s * adv_sca_3  &
-                                          +              ibit3_s * adv_sca_1  &
-                                             ) *                              &
-                                          ( sk(k,j,i)   - sk(k,j-1,i)    )    &
-                                      -      (  5.0_wp * ibit5_s * adv_sca_5  &
-                                          +              ibit4_s * adv_sca_3  &
-                                             ) *                              &
-                                          ( sk(k,j+1,i) - sk(k,j-2,i)    )    &
-                                      +      (           ibit5_s * adv_sca_5  &
-                                             ) *                              &
-                                          ( sk(k,j+2,i) - sk(k,j-3,i)    )    &
+                v_comp_s                = v(k,j,i) - v_gtrans + v_stokes_zu(k)
+                swap_flux_y_local(k,tn) = v_comp_s * (                         &
+                                             ( 37.0_wp * ibit5_s * adv_sca_5   &
+                                          +     7.0_wp * ibit4_s * adv_sca_3   &
+                                          +              ibit3_s * adv_sca_1   &
+                                             ) *                               &
+                                         ( sk(k,j,i)  + sk(k,j-1,i)     )      &
+                                       -     (  8.0_wp * ibit5_s * adv_sca_5   &
+                                          +              ibit4_s * adv_sca_3   &
+                                              ) *                              &
+                                         ( sk(k,j+1,i) + sk(k,j-2,i)    )      &
+                                      +      (           ibit5_s * adv_sca_5   &
+                                             ) *                               &
+                                        ( sk(k,j+2,i) + sk(k,j-3,i)     )      &
                                                      )
-#else
-                flux_s = swap_flux_y_local(k)
-                diss_s = swap_diss_y_local(k)
+
+                swap_flux_y_local(k,tn) = -ABS( v_comp_s ) * (                 &
+                                             ( 10.0_wp * ibit5_s * adv_sca_5   &
+                                          +     3.0_wp * ibit4_s * adv_sca_3   &
+                                          +              ibit3_s * adv_sca_1   &
+                                             ) *                               &
+                                          ( sk(k,j,i)   - sk(k,j-1,i)    )     &
+                                      -      (  5.0_wp * ibit5_s * adv_sca_5   &
+                                          +              ibit4_s * adv_sca_3   &
+                                             ) *                               &
+                                          ( sk(k,j+1,i) - sk(k,j-2,i)    )     &
+                                      +      (           ibit5_s * adv_sca_5   &
+                                             ) *                               &
+                                          ( sk(k,j+2,i) - sk(k,j-3,i)    )     &
+                                                             )
 #endif
-
-!
-!--             k index has to be modified near bottom and top, else array
-!--             subscripts will be exceeded.
+             ENDDO
+!
+!--          Now compute the fluxes and tendency terms for the horizontal and
+!--          vertical parts above the top of the highest topography. No degradation
+!--          for the horizontal parts, but for the vertical it is stell needed.
+             DO  k = nzb_max_l+1, nzt
+
+                u_comp    = u(k,j,i+1) - u_gtrans + u_stokes_zu(k)
+                flux_r(k) = u_comp * (                                         &
+                            37.0_wp * ( sk(k,j,i+1) + sk(k,j,i)   )            &
+                          -  8.0_wp * ( sk(k,j,i+2) + sk(k,j,i-1) )            &
+                          +           ( sk(k,j,i+3) + sk(k,j,i-2) ) ) * adv_sca_5
+                diss_r(k) = -ABS( u_comp ) * (                                 &
+                            10.0_wp * ( sk(k,j,i+1) - sk(k,j,i)   )            &
+                          -  5.0_wp * ( sk(k,j,i+2) - sk(k,j,i-1) )            &
+                          +           ( sk(k,j,i+3) - sk(k,j,i-2) ) ) * adv_sca_5
+#ifdef _OPENACC
+!
+!--             Recompute the left fluxes.
+                u_comp_l                  = u(k,j,i) - u_gtrans + u_stokes_zu(k)
+                swap_flux_x_local(k,j,tn) = u_comp_l * (                       &
+                                      37.0_wp * ( sk(k,j,i)   + sk(k,j,i-1) )  &
+                                    -  8.0_wp * ( sk(k,j,i+1) + sk(k,j,i-2) )  &
+                                    +           ( sk(k,j,i+2) + sk(k,j,i-3) )  &
+                                                       ) * adv_sca_5
+
+                swap_diss_x_local(k,j,tn) = -ABS( u_comp_l ) * (               &
+                                      10.0_wp * ( sk(k,j,i)   - sk(k,j,i-1) )  &
+                                    -  5.0_wp * ( sk(k,j,i+1) - sk(k,j,i-2) )  &
+                                    +           ( sk(k,j,i+2) - sk(k,j,i-3) )  &
+                                                               ) * adv_sca_5
+#endif
+
+                v_comp    = v(k,j+1,i) - v_gtrans + v_stokes_zu(k)
+                flux_n(k) = v_comp * (                                         &
+                            37.0_wp * ( sk(k,j+1,i) + sk(k,j,i)   )            &
+                          -  8.0_wp * ( sk(k,j+2,i) + sk(k,j-1,i) )            &
+                          +           ( sk(k,j+3,i) + sk(k,j-2,i) ) ) * adv_sca_5
+                diss_n(k) = -ABS( v_comp ) * (                                 &
+                            10.0_wp * ( sk(k,j+1,i) - sk(k,j,i)   )            &
+                          -  5.0_wp * ( sk(k,j+2,i) - sk(k,j-1,i) )            &
+                          +           ( sk(k,j+3,i) - sk(k,j-2,i) ) ) * adv_sca_5
+#ifdef _OPENACC
+!
+!--             Recompute the south fluxes.
+                v_comp_s                = v(k,j,i) - v_gtrans + v_stokes_zu(k)
+                swap_flux_y_local(k,tn) = v_comp_s * (                         &
+                                    37.0_wp * ( sk(k,j,i)   + sk(k,j-1,i) )    &
+                                  -  8.0_wp * ( sk(k,j+1,i) + sk(k,j-2,i) )    &
+                                  +           ( sk(k,j+2,i) + sk(k,j-3,i) )    &
+                                                     ) * adv_sca_5
+                swap_diss_y_local(k,tn) = -ABS( v_comp_s ) * (                 &
+                                    10.0_wp * ( sk(k,j,i)   - sk(k,j-1,i) )    &
+                                  -  5.0_wp * ( sk(k,j+1,i) - sk(k,j-2,i) )    &
+                                  +             sk(k,j+2,i) - sk(k,j-3,i)      &
+                                                             ) * adv_sca_5
+#endif
+             ENDDO
+!
+!--          Now, compute vertical fluxes. Split loop into a part treating the
+!--          lowest grid points with indirect indexing, a main loop without
+!--          indirect indexing, and a loop for the uppermost grip points with
+!--          indirect indexing. This allows better vectorization for the main loop.
+!--          First, compute the flux at model surface, which need has to be
+!--          calculated explicetely for the tendency at
+!--          the first w-level. For topography wall this is done implicitely by
+!--          advc_flag.
+             flux_t(nzb) = 0.0_wp
+             diss_t(nzb) = 0.0_wp
+
+             DO  k = nzb+1, nzb+1
                 ibit8 = REAL( IBITS(advc_flag(k,j,i),8,1), KIND = wp )
                 ibit7 = REAL( IBITS(advc_flag(k,j,i),7,1), KIND = wp )
                 ibit6 = REAL( IBITS(advc_flag(k,j,i),6,1), KIND = wp )
-
+!
+!--             k index has to be modified near bottom and top, else array
+!--             subscripts will be exceeded.
                 k_ppp = k + 3 * ibit8
                 k_pp  = k + 2 * ( 1 - ibit6  )
